Subject: bug#26995: 26.0.50; emacsclient --tty FILE flashes previous frame's buffer before loading FILE

From: Eli Zaretskii <[email-masked]>
Date: Fri, 19 May 2017 18:30:18 +0300

> From: Aaron Jensen <[email-masked]>
> Date: Fri, 19 May 2017 07:28:06 -0700
> 
> emacs -Q
> M-x server-start
> C-x C-f <pick some file with lots of text>
> 
> Back in terminal:
> 
> emacsclient --tty <some other file with different text>
> 
> Expected:
> 
> New frame is created in tty and it displays (immediately) the "other" file
> without flashing the file from the other frame.
> 
> Actual:
> 
> The file from the first frame is displayed briefly before loading the "other"
> file. With my full config, this "brief" display is roughly 2 seconds. With emacs
> -Q it's a pretty quick flash.
> 
> I don't think this was happening when I was running 25.1 because I actually made
> some changes to my config involving persp-mode to stop it from happening. After
> upgrading to 26.0.50, it started happening again.

I can indeed reproduce the described behavior, but I see the same in
Emacs 25.2 and in Emacs 24.5.  The reason is simple: the way server.el
is written, we first create the client frame, and only then show the
file there.  So the frame is created with no file to visit, and Emacs
always shows the last buffer in the new frame in those cases.

Maybe your workaround worked for Emacs 25, but no longer works with
Emacs 26?